{%- from "shuup/front/macros/general.jinja" import render_supplier_info -%}
{%- from "shuup_definite_theme/macros/basket.jinja" import render_basket_supplier_info -%}

{% macro render_basket_lines(basket) %}
    {% set lines = basket.get_final_lines() %}
    {% if lines|length %}
    <div class="list-group lines">
    {% set show_supplier_info = xtheme.get("show_supplier_info") %}
    {% if xtheme.get("group_items_by_supplier") %}
        {% set groupped_lines = xtheme.group_lines_by_supplier(lines) %}
        {% for supplier, lines in groupped_lines.items() %}
            <div class="list-group-item supplier-info-item">
                <div class="cells">
                    <div class="line-cell supplier-info-cell">
                        {%- if supplier -%}
                            {{- render_basket_supplier_info(supplier) -}}
                        {%- endif -%}
                    </div>
                </div>
            </div>
            {% for line in lines %}
                <div class="list-group-item">
                    <div class="cells">
                        {{ _render_basket_line(line, False) }}
                    </div>
                </div>
            {% endfor %}
        {% endfor %}
    {% else %}
        {% for line in lines %}
            <div class="list-group-item">
                <div class="cells">
                    {{ _render_basket_line(line, show_supplier_info) }}
                </div>
            </div>
        {% endfor %}
    {% endif %}
    </div>
    {% endif %}
{% endmacro %}

{% macro render_unorderable_basket_lines(basket) %}
    {% set unorderable_lines = basket.get_unorderable_lines() %}
    {% if unorderable_lines %}
        <div class="basket-unorderable-lines">
            <p class="text-danger">{% trans %}The following items are not currently available (or are not available in the desired quantity) and cannot be included in your order.{% endtrans %}</p>
            <div class="list-group lines">
                {% if xtheme.get("group_items_by_supplier") %}
                    {% set groupped_lines = xtheme.group_lines_by_supplier(unorderable_lines) %}
                    {% for supplier, lines in groupped_lines.items() %}
                        <div class="list-group-item supplier-info-item">
                            <div class="cells">
                                <div class="line-cell supplier-info-cell">
                                    {%- if supplier -%}
                                        {{- render_basket_supplier_info(supplier) -}}
                                    {%- endif -%}
                                </div>
                            </div>
                        </div>
                        {% for line in lines %}
                            <div class="list-group-item">
                                <div class="cells">
                                    {{ _render_basket_line(line) }}
                                </div>
                            </div>
                        {% endfor %}
                    {% endfor %}
                {% else %}
                    {% for line in unorderable_lines %}
                        <div class="list-group-item">
                            <div class="cells">
                                {{ _render_basket_line(line) }}
                            </div>
                        </div>
                    {% endfor %}
                {% endif %}
            </div>
        </div>
    {% endif %}
{% endmacro %}

{% macro _render_basket_line(line, show_supplier_info) %}
    {% set product = line.product %}
    {% set shop_product = line.shop_product %}
    <div class="line-cell product-image{% if not product %} hidden-xs{% endif %}">
        {% if product %}
            {% set image = product.primary_image %}
            {% if not image and product.is_variation_child() %}
                {% set image = product.variation_parent.primary_image %}
                {% set product_url = shuup.urls.model_url(product.variation_parent, supplier=line.supplier) %}
            {% else %}
                {% set product_url = shuup.urls.model_url(product, supplier=line.supplier) %}
            {% endif %}
            {% if image %}
                <a href="{{ product_url }}">
                    <img class="img-responsive" src="{{ image|thumbnail(size=(200, 200)) }}" alt="{{ line.text }}">
                </a>
            {% else %}
                <a href="{{ product_url }}">
                    <img class="img-responsive" src="{{ STATIC_URL }}shuup/front/img/no_image_thumbnail.png">
                </a>
            {% endif %}
        {% endif %}
    </div>
    <div class="line-cell name">
        {% if product %}
        <label>{% trans %}Product Name{% endtrans %}</label>
        {% else %}
        <label>{{ line.type.label|title }}</label>
        {% endif %}
        <div>
            <h4>
                {% if product %}
                    <a class="product-name" href="{{ shuup.urls.model_url(product, supplier=line.supplier) }}">{{ line.text }}</a>
                    {% if show_supplier_info and line.supplier %}{{ render_supplier_info(line.supplier) }}{% endif %}
                {% else %}
                    {{ line.text }}
                {% endif %}
            </h4>
        </div>
    </div>
    <div class="line-cell price">
        {% if show_prices() and not xtheme.get("hide_prices") %}
            <label>{% trans %}Unit Price{% endtrans %}</label>
            <div>
                <h4 class="text-left">
                    {% if line.is_discounted and line.base_price.value > 0 %}
                        {{ line|discounted_unit_price(allow_cache=False) }}
                        <br><small><s class="text-muted">{{ line|base_unit_price(allow_cache=False) }}</s></small>
                    {% else %}
                        {{ line|base_unit_price(allow_cache=False) }}
                    {% endif %}
                </h4>
            </div>
        {% endif %}
    </div>
    <div class="line-cell quantity">
        {% if product %}
        <label>{% trans %}Quantity{% endtrans %}</label>
        <div>
            {% if line.can_change_quantity %}
                <div>
                    <input
                        id="qty_{{ line.line_id }}"
                        type="number"
                        name="q_{{ line.line_id }}"
                        size="2"
                        class="line_quantity form-control"
                        step="{{ shop_product.quantity_step }}"
                        value="{{ line.quantity }}"
                        min="{{ shop_product.rounded_minimum_purchase_quantity }}">
                </div>
            {% else %}
                <div class="">{{ _("Quantity") }}: {{ line.quantity }}</div>
            {% endif %}
        </div>
        {% endif %}
    </div>
    <div class="line-cell price">
        {% if show_prices() and not xtheme.get("hide_prices") %}
            <label>{% trans %}Total Price{% endtrans %}</label>
            <div>
                <h4 class="text-left">
                    {{ line|price(allow_cache=False) }}
                    {% if line.is_discounted and line.base_price.value > 0 %}
                        <br><small><s class="text-muted">{{ line|base_price(allow_cache=False) }}</s></small>
                    {% endif %}
                </h4>
            </div>
        {% endif %}
    </div>
    {% if line.can_delete %}
        <button type="submit"
                class="btn btn-sm delete-btn delete-line"
                name="delete_{{ line.line_id }}"
                title="{% trans %}Remove product from basket{% endtrans %}">
            <i class="fa fa-times"></i>
        </button>
    {% endif %}
{% endmacro %}

{% macro continue_shopping_button() %}
    <a href="/"
       class="text-muted btn continue-shopping hidden-xs">
        <i class="fa fa-angle-double-left"></i>
        {% trans %}Continue Shopping{% endtrans %}
    </a>
{% endmacro %}

{% macro render_empty_basket_actions() %}
    <a href="/" class="btn btn-primary">
        <i class="fa fa-angle-double-left"></i>
        {% trans %}Continue Shopping{% endtrans %}
    </a>
{% endmacro %}

{% macro submit_coupon_code() %}
    function showErrorMessage(msg) {
        if(typeof window.flashMessage !== 'undefined') {
            flashMessage('alert-danger', '', msg);
        } else {
            alert(msg);
        }
    }
    $("#submit-code").click(function(e){
        e.preventDefault();
        const coupon = $("#discount-code").val();

        if (coupon.length) {
            // ajax request to command
            const data = {
                "command": "add_campaign_code",
                "code": coupon
            };

            $.ajax({
                url: "",
                method: "POST",
                data: data,
                success: function(response) {
                    if (response.ok) {
                        location.reload();
                    }
                    else {
                        showErrorMessage("{% trans %}Error!{% endtrans %} {% trans %}Coupon is not available.{% endtrans %}")
                    }
                },
                error: function() {
                    showErrorMessage("{% trans %}Error!{% endtrans %} {% trans %}Adding coupon failed.{% endtrans %}")
                }
            });
        }
    });
{% endmacro %}
